;-------------------------------------------------------------------------;
;                                    TIGA                                 ;
;          Copyright (C) 1989-1991  Texas Instruments Incorporated.       ;
;                            All Rights Reserved                          ;
;-------------------------------------------------------------------------;
;   TIGA 2-D Graphics Library include file                                ;
;-------------------------------------------------------------------------;
;                                                                         ;
;  file            extend.inc (usoft-Assembler version of extend.h)       ;
;                                                                         ;
;  description     This file contains references to functions contained   ;
;                  in the TIGA 2-D Graphics Library.  It should be        ;
;                  included in any application, written in Microsoft      ;
;                  assembler, which invokes a graphics library function.  ;
;                                                                         ; 
;                  Note that the tiga.inc header file must be included    ;  
;                  before this include file.                              ;
;                                                                         ;  
;-------------------------------------------------------------------------; 
; 05/01/89      Original version                        Graham Short      ;
;-------------------------------------------------------------------------;

;-----------------------------------------------------------------------;
;  Extended function Command Numbers                                    ;
;-----------------------------------------------------------------------;
cmSET_DSTBM             Equ     EXT_CP OR  0
cmSET_SRCBM             Equ     EXT_CP OR  1
cmSTYLED_LINE           Equ     EXT_CP OR  2
cmSWAP_BM               Equ     EXT_CP OR  3
cmDRAW_POLYLINE_A       Equ     EXT_CP OR  4
cmFILL_CONVEX_A         Equ     EXT_CP OR  5
cmFILL_POLYGON_A        Equ     EXT_CP OR  6
cmPATNFILL_CONVEX_A     Equ     EXT_CP OR  7
cmPATNFILL_POLYGON_A    Equ     EXT_CP OR  8
cmPATNPEN_POLYLINE_A    Equ     EXT_CP OR  9
cmPEN_POLYLINE_A        Equ     EXT_CP OR 10
cmBITBLT                Equ     EXT_DM OR 11
cmDRAW_LINE             Equ     EXT_DM OR 12
cmDRAW_OVAL             Equ     EXT_DM OR 13
cmDRAW_OVALARC          Equ     EXT_DM OR 14
cmDRAW_PIEARC           Equ     EXT_DM OR 15
cmDRAW_POINT            Equ     EXT_DM OR 16
cmDRAW_POLYLINE         Equ     EXT_DM OR 17
cmDRAW_RECT             Equ     EXT_DM OR 18
cmFILL_CONVEX           Equ     EXT_DM OR 19
cmFILL_OVAL             Equ     EXT_DM OR 20
cmFILL_PIEARC           Equ     EXT_DM OR 21
cmFILL_POLYGON          Equ     EXT_DM OR 22
cmFILL_RECT             Equ     EXT_DM OR 23
cmFRAME_OVAL            Equ     EXT_DM OR 24
cmFRAME_RECT            Equ     EXT_DM OR 25
cmGET_PIXEL             Equ     EXT_DM OR 26
cmPATNFILL_CONVEX       Equ     EXT_DM OR 27
cmPATNFILL_OVAL         Equ     EXT_DM OR 28
cmPATNFILL_PIEARC       Equ     EXT_DM OR 29
cmPATNFILL_POLYGON      Equ     EXT_DM OR 30
cmPATNFILL_RECT         Equ     EXT_DM OR 31
cmPATNFRAME_OVAL        Equ     EXT_DM OR 32
cmPATNFRAME_RECT        Equ     EXT_DM OR 33
cmPATNPEN_LINE          Equ     EXT_DM OR 34
cmPATNPEN_OVALARC       Equ     EXT_DM OR 35
cmPATNPEN_PIEARC        Equ     EXT_DM OR 36
cmPATNPEN_POINT         Equ     EXT_DM OR 37
cmPATNPEN_POLYLINE      Equ     EXT_DM OR 38
cmPEN_LINE              Equ     EXT_DM OR 39
cmPEN_OVALARC           Equ     EXT_DM OR 40
cmPEN_PIEARC            Equ     EXT_DM OR 41
cmPEN_POINT             Equ     EXT_DM OR 42
cmPEN_POLYLINE          Equ     EXT_DM OR 43
cmSEED_FILL             Equ     EXT_DM OR 44
cmSEED_PATNFILL         Equ     EXT_DM OR 45
cmSET_DRAW_ORIGIN       Equ     EXT_DM OR 46
cmSET_PENSIZE           Equ     EXT_DM OR 47
cmZOOM_RECT             Equ     EXT_DM OR 48
cmSET_PATN              Equ     EXT_DM OR 49
cmINSTALL_FONT          Equ     EXT_CP OR 50
cmSELECT_FONT           Equ     EXT_CP OR 51
cmDELETE_FONT           Equ     EXT_CP OR 52
cmSET_TEXTATTR          Equ     EXT_CP OR 53
cmGET_TEXTATTR          Equ     EXT_CP OR 54
cmTEXT_WIDTH            Equ     EXT_CP OR 55
cmGET_ENV               Equ     EXT_CP OR 56
cmDECODE_RECT           Equ     EXT_CP OR 57
cmENCODE_RECT           Equ     EXT_CP OR 58
cmMOVE_PIXEL            Equ     EXT_DM OR 59
cmPUT_PIXEL             Equ     EXT_DM OR 60
cmSTYLED_OVAL           Equ     EXT_DM OR 61
cmSTYLED_OVALARC        Equ     EXT_DM OR 62
cmSTYLED_PIEARC         Equ     EXT_DM OR 63
cmIN_FONT               Equ     EXT_CP OR 64

;-----------------------------------------------------------------------;
;  C-Packet function definitions                                        ;
;-----------------------------------------------------------------------;

SET_DSTBM       macro   __addrhi, __addrlo, __pitch, __xext, __yext, __psize
        _WORD           __psize
        _WORD           __yext
        _WORD           __xext
        _WORD           __pitch
        _DWORD          __addrhi, __addrlo
        _CALL           _cp_cmd,cmSET_DSTBM
                endm

SET_SRCBM       macro   __addrhi, __addrlo, __pitch, __xext, __yext, __psize
        _WORD           __psize
        _WORD           __yext
        _WORD           __xext
        _WORD           __pitch
        _DWORD          __addrhi, __addrlo
        _CALL           _cp_cmd,cmSET_SRCBM
                endm

STYLED_LINE     macro   __x1, __y1, __x2, __y2, __stylehi, __stylelo, __mode
        _WORD           __mode
        _DWORD          __stylehi, __stylelo
        _SWORD          __y2
        _SWORD          __x2
        _SWORD          __y1
        _SWORD          __x1
        _CALL           _cp_ret,cmSTYLED_LINE
                endm

SWAP_BM         macro
        _CALL           _cp_cmd,cmSWAP_BM
                endm

DRAW_POLYLINE_A macro   __n, __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        _WORD_PTR       ax,__ptrseg,__ptroff
        _WORD           __n
        _CALL           _cp_cmd_a,cmDRAW_POLYLINE_A
                endm

FILL_CONVEX_A   macro   __n, __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        _WORD_PTR       ax,__ptrseg,__ptroff
        _WORD           __n
        _CALL           _cp_cmd_a,cmFILL_CONVEX_A
                endm

FILL_POLYGON_A  macro   __n, __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        _WORD_PTR       ax,__ptrseg,__ptroff
        _WORD           __n
        _CALL           _cp_cmd_a,cmFILL_POLYGON_A
                endm

PATNFILL_CONVEX_A   macro   __n, __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        _WORD_PTR       ax,__ptrseg,__ptroff
        _WORD           __n
        _CALL           _cp_cmd_a,cmPATNFILL_CONVEX_A
                endm

PATNFILL_POLYGON_A  macro   __n, __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        _WORD_PTR       ax,__ptrseg,__ptroff
        _WORD           __n
        _CALL           _cp_cmd_a,cmPATNFILL_POLYGON_A
                endm

PATNPEN_POLYLINE_A macro   __n, __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        _WORD_PTR       ax,__ptrseg,__ptroff
        _WORD           __n
        _CALL           _cp_cmd_a,cmPATNPEN_POLYLINE_A
                endm

PEN_POLYLINE_A  macro   __n, __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        _WORD_PTR       ax,__ptrseg,__ptroff
        _WORD           __n
        _CALL           _cp_cmd_a,cmPEN_POLYLINE_A
                endm

INSTALL_FONT    macro   __fonthi, __fontlo
        _DWORD  __fonthi, __fontlo
        _CALL           _cp_ret,cmINSTALL_FONT
                endm

SELECT_FONT     macro   __font
        _WORD   __font
        _CALL           _cp_ret,cmSELECT_FONT
                endm

DELETE_FONT     macro   __font
        _WORD   __font
        _CALL           _cp_ret,cmDELETE_FONT
                endm

SET_TEXTATTR    macro   __conseg, __conoff, __count, __argseg, __argoff
        _WORD_PTR       __count, __argseg, __argoff
        _WORD           __count
        _STRING         __conseg, __conoff
        _CALL           _cp_ret,cmSET_TEXTATTR
                endm

GET_TEXTATTR    macro   __conseg, __conoff, __count, __argseg, __argoff
        _ALTWORD_PTR    __count, __argseg, __argoff
        _WORD           __count
        _STRING         __conseg, __conoff
        _CALL           _cp_alt,cmGET_TEXTATTR
                endm

TEXT_WIDTH      macro   __strseg, __stroff
        _STRING         __strseg, __stroff
        _CALL           _cp_ret,cmTEXT_WIDTH
                endm

DECODE_RECT     macro   __x, __y, __imagehi, __imagelo
        _DWORD          __imagehi, __imagelo
        _WORD           __y
        _WORD           __x
        _CALL           _cp_ret,cmDECODE_RECT
                endm

ENCODE_RECT     macro   __w, __h, __x, __y, __imagehi, __imagelo, __max
        _WORD           __max
        _DWORD          __imagehi, __imagelo
        _WORD           __y
        _WORD           __x
        _WORD           __h
        _WORD           __w
        _CALL           _cp_ret,cmENCODE_RECT
                        endm

GET_ENV             macro       __ptrseg,__ptroff
        _ALTBYTE_PTR    <SIZE ENVIRONMENT>,__ptrseg,__ptroff
        _CALL           _cp_alt,cmGET_ENV
                        endm
                                                                            
;-----------------------------------------------------------------------;
;  Direct-Mode function definitions                                     ;
;-----------------------------------------------------------------------;
BITBLT                  macro   __width, __height, __srcx, __srcy, __dstx, __dsty
        $WORD   __dsty
        $WORD   __dstx
        $WORD   __srcy
        $WORD   __srcx
        $WORD   __height
        $WORD   __width
        $CALL   _dm_cmd,cmBITBLT
                        endm

DRAW_LINE               macro   __x1, __y1, __x2, __y2
        $WORD   __y2
        $WORD   __x2
        $WORD   __y1
        $WORD   __x1
        $CALL   _dm_cmd,cmDRAW_LINE
                        endm

DRAW_OVAL               macro   __w, __h, __x, __y
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmDRAW_OVAL
                        endm

DRAW_OVALARC            macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmDRAW_OVALARC
                        endm

DRAW_PIEARC             macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmDRAW_PIEARC
                        endm

DRAW_POINT              macro   __x, __y
        $WORD   __y
        $WORD   __x
        $CALL   _dm_cmd,cmDRAW_POINT
                        endm

DRAW_POLYLINE           macro   __n, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        shl     ax,1
        $WORD   ax
        $CALL   _dm_psnd,cmDRAW_POLYLINE
                        endm

DRAW_RECT               macro   __w, __h, __x, __y
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmDRAW_RECT
                        endm

FILL_CONVEX             macro   __n, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        shl     ax,1
        $WORD   ax
        $CALL   _dm_psnd,cmFILL_CONVEX
                        endm

FILL_OVAL               macro   __w, __h, __x, __y
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmFILL_OVAL
                        endm

FILL_PIEARC             macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmFILL_PIEARC
                        endm

FILL_POLYGON            macro   __n, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        shl     ax,1
        $WORD   ax
        $CALL   _dm_psnd,cmFILL_POLYGON
                        endm

FILL_RECT               macro   __w, __h, __x, __y
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmFILL_RECT
                        endm

FRAME_OVAL              macro   __w, __h, __x, __y, __dx, __dy
        $WORD   __dy
        $WORD   __dx
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmFRAME_OVAL
                        endm

FRAME_RECT              macro   __w, __h, __x, __y, __dx, __dy
        $WORD   __dy
        $WORD   __dx
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmFRAME_RECT
                        endm

GET_PIXEL               macro   __x, __y
        $WORD   __y
        $WORD   __x
        $CALL   _dm_ret,cmGET_PIXEL
                        endm

PATNFILL_CONVEX             macro   __n, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        shl     ax,1
        $WORD   ax
        $CALL   _dm_psnd,cmPATNFILL_CONVEX
                        endm

PATNFILL_OVAL               macro   __w, __h, __x, __y
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPATNFILL_OVAL
                        endm

PATNFILL_PIEARC             macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPATNFILL_PIEARC
                        endm

PATNFILL_POLYGON            macro   __n, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        shl     ax,1
        $WORD   ax
        $CALL   _dm_psnd,cmPATNFILL_POLYGON
                        endm

PATNFILL_RECT               macro   __w, __h, __x, __y
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPATNFILL_RECT
                        endm

PATNFRAME_OVAL              macro   __w, __h, __x, __y, __dx, __dy
        $WORD   __dy
        $WORD   __dx
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPATNFRAME_OVAL
                        endm

PATNFRAME_RECT              macro   __w, __h, __x, __y, __dx, __dy
        $WORD   __dy
        $WORD   __dx
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPATNFRAME_RECT
                        endm

PATNPEN_LINE               macro   __x1, __y1, __x2, __y2
        $WORD   __y2
        $WORD   __x2
        $WORD   __y1
        $WORD   __x1
        $CALL   _dm_cmd,cmPATNPEN_LINE
                        endm

PATNPEN_OVALARC            macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPATNPEN_OVALARC
                        endm

PATNPEN_PIEARC             macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPATNPEN_PIEARC
                        endm

PATNPEN_POINT              macro   __x, __y
        $WORD   __y
        $WORD   __x
        $CALL   _dm_cmd,cmPATNPEN_POINT
                        endm

PATNPEN_POLYLINE           macro   __n, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        shl     ax,1
        $WORD   ax
        $CALL   _dm_psnd,cmPATNPEN_POLYLINE
                        endm

PEN_LINE               macro   __x1, __y1, __x2, __y2
        $WORD   __y2
        $WORD   __x2
        $WORD   __y1
        $WORD   __x1
        $CALL   _dm_cmd,cmPEN_LINE
                        endm

PEN_OVALARC            macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPEN_OVALARC
                        endm

PEN_PIEARC             macro   __w, __h, __x, __y, __theta, __arc
        $WORD   __arc
        $WORD   __theta
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmPEN_PIEARC
                        endm

PEN_POINT              macro   __x, __y
        $WORD   __y
        $WORD   __x
        $CALL   _dm_cmd,cmPEN_POINT
                        endm

PEN_POLYLINE           macro   __n, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        mov     ax,__n
        shl     ax,1
        shl     ax,1
        $WORD   ax
        $CALL   _dm_psnd,cmPEN_POLYLINE
                        endm

SEED_FILL               macro   __x, __y, __bufhi, __buflo, __size
        $WORD   __size
        $DWORD  __bufhi, __buflo
        $WORD   __y
        $WORD   __x
        $CALL   _dm_cmd,cmSEED_FILL
                        endm

SEED_PATNFILL           macro   __x, __y, __bufhi, __buflo, __size
        $WORD   __size
        $DWORD  __bufhi, __buflo
        $WORD   __y
        $WORD   __x
        $CALL   _dm_cmd,cmSEED_PATNFILL
                        endm

SET_DRAW_ORIGIN         macro   __x, __y
        $WORD   __y
        $WORD   __x
        $CALL   _dm_cmd,cmSET_DRAW_ORIGIN
                        endm

SET_PENSIZE             macro   __w, __h
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmSET_PENSIZE
                        endm

ZOOM_RECT               macro   __ws, __hs, __xs, __ys, __wd, __hd, __xd, __yd, __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        $WORD   __yd
        $WORD   __xd
        $WORD   __hd
        $WORD   __wd
        $WORD   __ys
        $WORD   __xs
        $WORD   __hs
        $WORD   __ws
        $CALL   _dm_cmd,cmZOOM_RECT
                        endm

SET_PATN                macro   __ptrseg, __ptroff
        $DWORD  __ptrseg, __ptroff
        $WORD   <SIZE CONFIG>
        $CALL   _dm_psnd,cmSET_PATN
                        endm

MOVE_PIXEL              macro   __xs, __ys, __xd, __yd
        $WORD   __yd
        $WORD   __xd
        $WORD   __ys
        $WORD   __xs
        $CALL   _dm_cmd,cmMOVE_PIXEL
                        endm

PUT_PIXEL               macro   __phi, __plo, __x, __y
        $WORD   __y
        $WORD   __x
        $DWORD  __phi, __plo
        $CALL   _dm_cmd,cmPUT_PIXEL
                        endm

STYLED_OVAL             macro   __w, __h, __x, __y, __shi, __slo, __m
        $WORD   __m
        $DWORD  __shi, __slo
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmSTYLED_OVAL
                        endm

STYLED_OVALARC          macro   __w, __h, __x, __y, __t, __a, __shi, __slo, __m
        $WORD   __m
        $DWORD  __shi, __slo
        $WORD   __a
        $WORD   __t
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmSTYLED_OVALARC
                        endm

STYLED_PIEARC           macro   __w, __h, __x, __y, __t, __a, __shi, __slo, __m
        $WORD   __m
        $DWORD  __shi, __slo
        $WORD   __a
        $WORD   __t
        $WORD   __y
        $WORD   __x
        $WORD   __h
        $WORD   __w
        $CALL   _dm_cmd,cmSTYLED_PIEARC
                        endm

IN_FONT                 macro   __s, __e
        $WORD   __e
        $WORD   __s
        $CALL   _cp_ret,cmIN_FONT   
                        endm

        .List
