program xhrdemo (input,output);
(*$C-*)

(***************************************
 *                                     *
 *             XHR-Demoprogram         *
 *             ELSA GmbH               *
 *             Aachen                  *
 *             Germany (West)          *
 *                                     *
 *             Author: P. Wieninger    *
 *             dec. 15th 86            *
 *                                     *
 ***************************************)

type
  String40 = string[40];
  String80 = string[80];
  KeyResult = (Nothing, NextPicture, Quitkey);

const
  autodemo :boolean = true;
  Dealer: String80 = '';
  UpperScreen=0;
  BaseScreen=1;
  LowerScreen=2;
  WindowScreen=3;

  Black=0;
  Blue=1;
  Green=2;
  Cyan=3;
  Red=4;
  Magenta=5;
  Brown=6;
  LightGray=7;
  DarkGrey=8;
  LightBlue=9;
  LightGreen=10;
  LightCyan=11;
  LightRed=12;
  LightMagenta=13;
  LightYellow=14;
  LightWhite=15;

  PCXHR=0;
  PCDXHR=1;
  PCXXHR8=2;
  PCXXHR16=3;

var
  DelayFlag,Quit,EndProc: boolean;
  XWidth,YWidth,CentX,CentY,RepeatCounter: integer;
  DelayStart,DelayBase: real;
  C: char;
  Upper,Lower,Window: boolean;

(*******************************
 *                             *
 *         XHR-Include         *
 *                             *
 *******************************)

(*$I XHRTRB.INC*)


(*******************************
 *                             *
 *         KEY Test Reset      *
 *                             *
 *******************************)

(* Resets global 'EndProc'-flag.
   Initializes RepeatCounter. *)

procedure ResetKeyTest (Var1: integer);
begin
  RepeatCounter:=Var1;
  EndProc:=false;
end;



(*******************************
 *                             *
 *         KEY Test            *
 *                             *
 *******************************)

(* tests keyboardinput for 'Q' and 'X'.
   Sets global flags 'Quit' and 'Endproc' if required.
   Decrements RepeatCounter if Autodemo.
   Waits for new keyinput if keypressed and not Autodemo-Mode *)

procedure KeyTest;

var
  chrct: char;

begin
  chrct:=' ';
  if AutoDemo then
  begin
    RepeatCounter:=RepeatCounter-1;
    if keypressed then read(kbd,chrct);
  end
  else
  begin
    if keypressed then
    begin
      read(kbd,chrct);
      if (upcase(chrct)<>'X') and (upcase(chrct)<>'Q') and (ord(chrct)<>3)
        then read(kbd,chrct);
    end;
  end;
  if (RepeatCounter=0) or (upcase(chrct)='Q') or
     (upcase(chrct)='X') or (ord(chrct)=3) then
  begin
    EndProc:=true;
    if (upcase(chrct)='Q') or (ord(chrct)=3) then Quit:=true
  end;
end;



(*******************************
 *                             *
 *         Wait init           *
 *                             *
 *******************************)

(* Initializes the values used by following 'Wait'-procedure.
   First Parameter is the start delayvalue, second parameter
   is the reverse decrement factor *)


procedure WaitInit (Val1: integer; Val2: real);

begin
  DelayStart:=Val1;
  DelayBase:=Val2;
  DelayFlag:=true;
end;



(*******************************
 *                             *
 *         Wait                *
 *                             *
 *******************************)

(* Produces variable delays for speedup-effect *)

procedure Wait;

Var
  DelayTime: integer;

begin
  if DelayFlag then
  begin
    DelayTime:=round(DelayStart);
    Delay(DelayTime);
    If DelayTime=0 then DelayFlag:=false;
    DelayStart:=Delaystart/DelayBase;
  end;
end;

(*******************************
 *                             *
 *         Parse Params        *
 *                             *
 *******************************)

(* Reads the commandline of MS-DOS call *)

procedure ParsParams;
var
  Pntr: integer;

  function ConvertString (Line: string80) : string80;
  var i:integer;
  begin
    for i:=1 to length(Line) do Line[i]:=upcase(Line[i]);
    ConvertString:=Line;
  end;

  function UnderLine2Blank (Line: string80) : string80;
  var i: integer;
  begin
    for i:=1 to length(Line) do
      if Line[i]='_' then Line[i]:=' ';
    UnderLine2Blank:=Line;
  end;


begin
  for Pntr:=1 to ParamCount do
    if ConVertString(ParamStr(Pntr))='NOAUTO'
      then AutoDemo:=false
      else Dealer:=UnderLine2Blank(ParamStr(Pntr));
end;


(*******************************
 *                             *
 *         INIT                *
 *                             *
 *******************************)

(* Initializes XHR and assigns memory to XHR.
   Defines the parameters (origin, colors ..) of each screen. *)

procedure Init;

begin
  Quit:=false;

  xhrini(0,0);
  if rdmem(1)<40 then upper:=false else upper:=true;
  if rdmem(5)<40 then lower:=false else lower:=true;
  if (rdmem(6)<192) or (rdmem(7)<64) then window:=false else window:=true;

  if upper then
  begin
    wscrn(0);                          (* define upperscreen *)
    fscrn(Blue);
    deforg(8,6);
    colors(Blue,LightWhite);
  end;

  wscrn(1);                            (* define basescreen *)
  fscrn(Black);
  if lower then deforg(0,40);
  XWidth:=rdini(7);
  YWidth:=rdini(8);
  if upper then YWidth:=YWidth-40;
  if lower then YWidth:=YWidth-40;
  if (YWidth+64)>XWidth then YWidth:=XWidth-64;

  if lower then
  begin
    wscrn(2);                          (* define lowerscreen *)
    fscrn(Red);
    deforg(8,6);
    colors(Red,LightWhite);
  end;

  if window then
  begin
    wscrn(3);                            (* define windowscreen *)
    fscrn(LightGray);
    deforg(8,40);
    colors(LightGray,Black);
  end;


  wscrn(1);
  defar(0,0,XWidth-1,YWidth-1);        (* define protected area *)
  armod(2);                            (* protected mode ON *)
  if upper then show(0,0,40);          (* show upper 40 lines *)
  if lower then show(2,0,40);          (* show lower 40 lines *)
  CentX:=XWidth div 2;                 (* calc. center of basescreen *)
  CentY:=YWidth div 2;
end;


(*******************************
 *                             *
 *         StringOut           *
 *                             *
 *******************************)

(* draws a string of characters at CP-position *)

procedure StringOut (XText: String80; ChrZoom: integer);
var
  ChrPos: integer;
begin
  for ChrPos:=1 to length(XText) do
    chrct(ord(copy(XText,ChrPos,1)),ChrZoom,ChrZoom,0);
end;



(*******************************
 *                             *
 *         COMMENT             *
 *                             *
 *******************************)

(* prints the comments on upper- lower- and windowscreen.
   Backslash means carriage return (used for window only). *)

procedure comment (PrintScreen: Integer; CText: String80);
var
  ChrPos,LinePos,ChrZoom: integer;
begin
  if  ((PrintScreen=0) and Upper)
    or((PrintScreen=2) and Lower)
    or((PrintScreen=3) and Window) then
  begin
    wscrn(PrintScreen);                    (* switch to requested screen *)
    case PrintScreen of
      UpperScreen  : fscrn(Blue);
      LowerScreen  : fscrn(Red);
      WindowScreen : fscrn(LightGray);
    end;
    if Printscreen=WindowScreen
      then ChrZoom:=1
      else ChrZoom:=2;
    ChrPos:=1;
    LinePos:=0;
    repeat
      amove(0,-LinePos*(16*(ChrZoom)));
      while (ChrPos<=length(CText)) and (copy(CText,ChrPos,1)<>'\') do
      begin
        chrct(ord(copy(CText,ChrPos,1)),ChrZoom,ChrZoom,0);
        ChrPos:=ChrPos+1;
      end;
      ChrPos:=ChrPos+1;
      LinePos:=LinePos+1;
    until ChrPos>length(CText);
    wscrn(1);
  end;
end;


(*******************************
 *                             *
 *         ELSA LOGO           *
 *                             *
 *******************************)

(* draws the ELSA-Logo at CP's Position with variable ZoomFactor *)


procedure ELSA (Col: integer ;ZF: real);
var
  PosX,PosY: integer;

  function X (W: integer) : integer;
  begin
    X:= PosX+round(ZF*W);
  end;

  function Y (W: integer) : integer;
  begin
    Y:= PosY+round(ZF*W);
  end;

begin
  PosX:=GetCPx;
  PosY:=GetCPy;
  colors(Col,Col);

  (***** Drawing of frame *****)

  amove(X(0),Y(2));
  aline(X(0),Y(33));
  aarc(X(2),Y(33),X(2),Y(35),1);
  aline(X(106),Y(35));
  aarc(X(106),Y(33),X(108),Y(33),1);
  aline(X(108),Y(2));
  aarc(X(106),Y(2),X(106),Y(0),1);
  aline(X(2),Y(0));
  aarc(X(2),Y(2),X(0),Y(2),1);

  amove(X(4),Y(3));
  aline(X(4),Y(32));
  aarc(X(6),Y(32),X(6),Y(34),1);
  aline(X(102),Y(34));
  aarc(X(102),Y(32),X(104),Y(32),1);
  aline(X(104),Y(3));
  aarc(X(102),Y(3),X(102),Y(1),1);
  aline(X(6),Y(1));
  aarc(X(6),Y(3),X(4),Y(3),1);

  amove(X(2),Y(2));
  paint(Col,0);
  amove(X(106),Y(2));
  paint(Col,0);

  (***** Drawing of letter 'E' *****)

  amove(X(7),Y(6));
  aline(X(7),Y(29));
  aarc(X(9),Y(29),X(9),Y(31),1);
  aline(X(29),Y(31));
  aline(X(29),Y(30));
  aline(X(13),Y(30));
  aarc(X(13),Y(28),X(11),Y(28),0);
  aline(X(11),Y(18));
  aline(X(29),Y(18));
  aline(X(29),Y(17));
  aline(X(11),Y(17));
  aline(X(11),Y(7));
  aarc(X(13),Y(7),X(13),Y(5),0);
  aline(X(29),Y(5));
  aline(X(29),Y(4));
  aline(X(9),Y(4));
  aarc(X(9),Y(6),X(7),Y(6),1);
  amove(X(9),Y(6));
  paint(Col,0);

  (***** Drawing of letter 'L' *****)

  amove(X(31),Y(6));
  aline(X(31),Y(31));
  aline(X(35),Y(31));
  aline(X(35),Y(7));
  aarc(X(37),Y(7),X(37),Y(5),0);
  aline(X(53),Y(5));
  aline(X(53),Y(4));
  aline(X(33),Y(4));
  aarc(X(33),Y(6),X(31),Y(6),1);
  amove(X(33),Y(6));
  paint(Col,0);

  (***** Drawing of letter 'S' *****)

  amove(X(55),Y(4));
  aline(X(75),Y(4));
  aarc(X(75),Y(6),X(77),Y(6),0);
  aline(X(77),Y(16));
  aarc(X(75),Y(16),X(75),Y(18),0);
  aline(X(61),Y(18));
  aarc(X(61),Y(20),X(59),Y(20),1);
  aline(X(59),Y(28));
  aarc(X(61),Y(28),X(61),Y(30),1);
  aline(X(77),Y(30));
  aline(X(77),Y(31));
  aline(X(57),Y(31));
  aarc(X(57),Y(29),X(55),Y(29),0);
  aline(X(55),Y(19));
  aarc(X(57),Y(19),X(57),Y(17),0);
  aline(X(71),Y(17));
  aarc(X(71),Y(15),X(73),Y(15),1);
  aline(X(73),Y(7));
  aarc(X(71),Y(7),X(71),Y(5),1);
  aline(X(55),Y(5));
  aline(X(55),Y(4));
  amove(X(57),Y(19));
  paint(Col,0);
  amove(X(75),Y(6));
  paint(Col,0);

  (***** Drawing of letter 'A' *****)

  amove(X(79),Y(4));
  aline(X(79),Y(29));
  aarc(X(81),Y(29),X(81),Y(31),1);
  aline(X(99),Y(31));
  aarc(X(99),Y(29),X(101),Y(29),1);
  aline(X(101),Y(4));
  aline(X(97),Y(4));
  aline(X(97),Y(17));
  aline(X(80),Y(17));
  aline(X(80),Y(4));
  aline(X(79),Y(4));
  amove(X(80),Y(18));
  aline(X(80),Y(28));
  aarc(X(82),Y(28),X(82),Y(30),1);
  aline(X(95),Y(30));
  aarc(X(95),Y(28),X(97),Y(28),1);
  aline(X(97),Y(18));
  aline(X(80),Y(18));
  amove(X(80),Y(30));
  dot;
  amove(X(99),Y(6));
  paint(Col,0);

  amove(PosX,PosY);
end;




(*******************************
 *                             *
 *       DEMO: PRESENTS        *
 *                             *
 *******************************)

(* Shows the first picture of the demo *)

procedure presents;
var
  Count,Direct: integer;
  z: real;

begin
  ResetKeyTest(3000);

  drwmod(64);
  fscrn(LightWhite);
  colors(LightWhite,Black);

  (*Dealer := '';*)

  if Dealer='' then
  begin
    amove(CentX-3*4*16,240);
    stringout('proudly presents',3);
  end
  else
  begin
    amove(CentX-3*4*(length(dealer)+2),280);
    stringout('& '+Dealer,3);
    amove(CentX-2*4*15,220);
    stringout('proudly present',2);
  end;

  z:=CentX/130;
  amove(CentX-trunc(z*54),CentY+80);
  ELSA(0,z);                            (* draw ELSA-Logo *)



  delay(2000);

  colors(LightRed,Black);              (* draw 'XHR' with rising zoom *)
  for Count:=1 to 16 do
  begin
    amove(CentX-16*3*4,-2*16);
    StringOut('XHR',Count);
    delay(50);
  end;

  colors(White,White);
  amove(0,0);
  rfrct(XWidth-1,4);
  colors(LightRed,Black);
  delay(1000);

  if upper then
  begin
    comment(UpperScreen,'this is the upper screen');
    delay(1000);
  end;
  if lower then
  begin
    comment(LowerScreen,'this is the lower screen');
    delay(1000);
  end;

  if window then
  begin
    wposit(100,100);
    comment(WindowScreen,'and here\is the\WINDOW');
    if window then show(3,192,64);

    (***** move window up/down *****)

    WaitInit(15,1.004);
    Count:=100;
    Direct:=1;                           (* upward direction *)
    repeat
      repeat
        wposit(100,Count);               (* posit window *)
        delay(5);
        Wait;
        Count:=Count+Direct;             (* increment/decrement Y-Position *)
        KeyTest;
      until (Count=412) or (Count=0) or EndProc;
      Direct:=-Direct;                   (* toggle direction *)
    until EndProc;
  end
  else delay(1500);
end;


(*******************************
 *                             *
 *       DEMO: Circles         *
 *                             *
 *******************************)


procedure circles;
var
  Count,Col,Cnt,Limit:integer;

begin

  (***** Erase picture with some effects *****)

  opmod(64);
  colors(LightBlue,LightBlue);
  for Count:=0 to XWidth-1 do
  begin
    amove(Count,0);
    Cnt:=0;
    repeat
      rline(0,100);
      rmove(0,100);
      Cnt:=Cnt+200;
    until Cnt>=YWidth;
    amove(XWidth-1-Count,100);
    Cnt:=0;
    repeat
      rline(0,100);
      rmove(0,100);
      cnt:=Cnt+200;
    until Cnt>=YWidth;
  end;


  colors(LightWhite,LightWhite);
  amove(CentX,CentY);
  dot;
  for Count:=1 to CentX do
  begin
    amove(CentX-Count,CentY-trunc(YWidth/XWidth*Count));
    rrct(2*Count,2*trunc(YWidth/XWidth*Count));
  end;

  comment(UpperScreen,'Warming Up:');
  comment(LowerScreen,'Circles');
  drwmod(67);

  (***** Draw circles *****)

  WaitInit(20,1.002);
  ResetKeyTest(20);

  if (YWidth > 800)
    then limit := 400
    else limit := YWidth div 2;
  amove(CentX,CentY);                  (* Move to center of basescreen *)
  Col:=1;
  repeat
    colors(Col,Col);                   (* define color *)
    for Count:=0 to Limit do
    begin
      crcl(Count);                     (* draw a circle radius 'Count' *)
      Wait;                            (* 'speedup' delay *)
    end;
    Col:=(Col mod 15)+1;               (* next color *)
  KeyTest;                             (* check keyboard *)
  until EndProc;

end;



(*******************************
 *                             *
 *       DEMO: Ellipses        *
 *                             *
 *******************************)

procedure ellipses;
var
  Count,AB,Col:integer;

begin

  (***** erase screen with some effects *****)

  drwmod(64);
  for Count:=1 to CentX do
  begin
    colors((Count shr 4) mod 16,(Count shr 4) mod 16);
    amove(CentX-Count,CentY-Count);
    rrct(Count*2,Count*2);
  end;
  colors(Black,Black);
  amove(CentX,CentY);
  dot;
  for Count:=1 to CentX do
  begin
    amove(CentX-Count,CentY-Count);
    rrct(Count*2,Count*2);
  end;

  comment(UpperScreen,'No Problem:');
  comment(LowerScreen,'ELLIPSES');

  (***** Draw ellipses *****)

  amove(CentX,CentY);                  (* Move to center of basescreen *)
  Col:=LightWhite;
  WaitInit(20,1.004);
  ResetKeyTest(20);
  repeat
    for Count:=2 to (XWidth div 8)-3 do
    begin
      Col:=(Col+1) mod 256;
      if (Col mod 16)=0 then colors(Col div 16,Col div 16);
      elps(10 + (Count-2) mod 8,10 - (Count-2) mod 8,Count*4);
      Wait;
    end;
    KeyTest;                           (* check keyboard *)
  until EndProc;

end;


(*******************************
 *                             *
 *       DEMO: ARCS            *
 *                             *
 *******************************)

procedure arcs;
var
  Count,Dist,Col: integer;
  AngleTab: array[0..239] of integer;

begin

  (***** erase screen with some effects *****)

  drwmod(64);
  colors(0,0);
  for Count:=0 to YWidth do
  begin
    amove(0,Count);
    aline(XWidth,YWidth-Count);
  end;
  for Count:=0 to XWidth do
  begin
    amove(XWidth-Count,0);
    aline(Count,YWidth);
  end;


  (***** calculate the starting and ending points of the arcs *)

  Count:=0;
  repeat
    AngleTab[count]  :=round((Count+10)*cos(1.62+0.02*Count/4));
    AngleTab[count+1]:=round((Count+10)*sin(1.62+0.02*Count/4));
    AngleTab[count+2]:=round((Count+10)*cos(1.67+0.1 *Count/4));
    AngleTab[count+3]:=round((Count+10)*sin(1.67+0.1 *Count/4));
    Count:=Count+4;
  until Count=240;

  comment(UpperScreen,'Easy to generate:');
  comment(Lowerscreen,'circle arcs');

  (***** draw circle arcs *****)

  Count:=0;
  ResetKeyTest(3000);
  repeat
    colors((Count div 4) mod 15 +1,(Count div 4) mod 15 +1);
    amove(CentX-20+AngleTab[Count],CentY-60+AngleTab[Count+1]);
    aarc(CentX-20,CentY-60,
         CentX-20+AngleTab[Count+2],CentY-60+AngleTab[Count+3],1);
    Count:=Count+4;
  until Count=240;

  repeat
    KeyTest;                           (* check keyboard *)
    delay(1);
  until EndProc;

end;


(*******************************
 *                             *
 *       DEMO: Sweep           *
 *                             *
 *******************************)

procedure sweep;
var
  Count1,Count2,Col: integer;

begin

  (***** erase screen with some effects *****)

  opmod(0);
  for Col:=1 downto 0 do
  begin
    colors(Col*4,Col*4);
    for Count1:=0 to 32 do
    begin
      for Count2:=0 to XWidth div 64 -1 do
      begin
        amove(Count2 * 64 +32 + Count1,0);
        rline(0,YWidth);
        rmove(-2*Count1,-YWidth);
        rline(0,YWidth);
      end;
    end;
  end;

  comment(UpperScreen,'Vector Drawings in');
  comment(LowerScreen,'Read-Modify-Write Mode');

  (***** perform vector drawing *****)

  ResetKeyTest(3);
  opmod(3);                            (* EXOR mode ON *)
  Col:=LightYellow;
  repeat
    Col:=(Col mod 15)+1;               (* next color *)
    colors(Col,Col);                   (* define XHR color registers *)
    for Count1:=0 to XWidth-1 do
    begin
      amove(0,0);                      (* move to lowerleft corner (base) *)
      aline(Count1,YWidth);            (* and draw absolute line *)
    end;
    Col:=(Col mod 15)+1;               (* next color *)
    colors(Col,Col);                   (* define XHR color registers *)
    for Count1:=YWidth downto 0 do
    begin
      amove(0,0);                      (* move to lowerleft corner (base) *)
      aline(Xwidth,Count1);            (* and draw absolute line *)
    end;
    Col:=(Col mod 15)+1;               (* next color *)
    colors(Col,Col);                   (* define XHR color registers *)
    for Count1:=0 to YWidth do
    begin
      amove(Xwidth-1,0);               (* move to lowerright corner (base) *)
      aline(0,Count1);                 (* and draw absolute line *)
    end;
    Col:=(Col mod 15)+1;               (* next color *)
    colors(Col,Col);                   (* define XHR color registers *)
    for Count1:=0 to XWidth-1 do
    begin
      amove(XWidth-1,0);               (* move to lowerright corner *)
      aline(Count1,YWidth);            (* and draw absolute line *)
    end;
    KeyTest;                           (* check keyboard *)
  until EndProc;

end;


(*******************************
 *                             *
 *       DEMO: BaseZoom        *
 *                             *
 *******************************)

procedure BaseZoom;
var
  ZoomFact,MaxZoom: integer;

begin
  if rdini(-1) in [0,1,10,11,12,13,14,15] then
  begin
    if rdini(-1) in [0,1]
      then MaxZoom:=16
      else MaxZoom:=2;

    comment(UpperScreen,'No Problem:');
    comment(Lowerscreen,'HARDWARE-ZOOM');

    if window then show(WindowScreen,0,0);               (* Window OFF *)

    ResetKeyTest(16 div MaxZoom);
    repeat
      delay(400);
      for Zoomfact:=2 to MaxZoom do
      begin
        zoom(ZoomFact,ZoomFact);         (* X- and Y-zoom ==> XHR *)
        delay(200);
      end;
      if (MaxZoom = 2) then delay(500);

      delay(400);
      for ZoomFact:=MaxZoom-1 downto 1 do
      begin
        zoom(ZoomFact,ZoomFact);         (* X- and Y-zoom ==> XHR *)
        delay(200);
      end;
      if (MaxZoom = 2) then delay(500);

      KeyTest;                                  (* check keyboard *)
    until EndProc;
    if window then show(WindowScreen,144,64);        (* Window ON *)
  end;
end;


(*******************************
 *                             *
 *       DEMO: FilledRects     *
 *                             *
 *******************************)

procedure FilledRects;
var
  Col,Count: integer;

begin

  (***** erase screen with some effects *****)

  drwmod(64);
  colors(LightWhite,LightWhite);                       (* color ==> XHR *)
  amove(CentX,CentY);                                  (* move to center *)
  dot;                                                 (* draw pixel *)
  for Count:=0 to XWidth do
  begin
    amove(CentX,CentY +Count);
    rline(Count,-Count);                               (* relative lines *)
    rline(-Count,-Count);
    rline(-Count,Count);
    rline(Count,Count);
  end;

  (***** draw filled rectangles at random positions *****)

  ResetKeyTest(3000);
  drwmod(0);
  repeat
    Col:=Random(256);                                  (* calc color *)
    colors(Col,Col);                                   (* color ==> XHR *)
    amove(random(XWidth-140),random(YWidth-100));      (* lowerleft corner *)
    rfrct(random(100)+40,random(50)+50);               (* draw filled rect. *)
    KeyTest;                                           (* check keyboard *)
  until EndProc;

end;


(*******************************
 *                             *
 *       DEMO: Cake            *
 *                             *
 *******************************)

procedure Cake;
var
  Count: integer;

begin

  (***** erase screen with some effects *****)

(*
  drwmod(64);
  amove(CentX,CentY);
  colors(Blue,Blue);
  fcrcl(round(sqrt(sqr(XWidth/2) + sqr(YWidth/2))));
  colors(Black,Black);
  fcrcl(round(sqrt(sqr(XWidth/2) + sqr(YWidth/2))));
*)

  drwmod(66);
  colors($c,$c);
  for Count:=0 to XWidth div 2 do
  begin
    amove(CentX-Count,0);
    rline(0,YWidth);
    amove(Centx+Count,0);
    rline(0,YWidth);
  end;

  colors(0,0);
  for Count:=YWidth div 2 downto 0 do
  begin
    amove(0,CentY+Count);
    rline(XWidth,0);
    amove(0,Centy-Count);
    amove(0,Centy-Count);
    rline(XWidth,0);
  end;
  drwmod(64);





  comment(UpperScreen,'Complex Pictures');
  comment(LowerScreen,'few Data');

  (***** draw outlines of cake *****)

  colors(LightWhite,LightWhite);                       (* colors ==> XHR *)
  amove(CentX,CentY);                                  (* move CP *)
  aline(CentX+176,CentY+88);                           (* absolute line *)
  aearc(4,1,CentX,CentY,CentX+241,CentY-32,0);         (* abs. ellipses arc *)
  aline(CentX,CentY);
  amove(CentX-250,CentY-50);
  aearc(4,1,CentX,CentY-50,CentX+241,CentY-82,0);
  aline(CentX+241,CentY-32);
  amove(CentX-250,CentY);
  aline(CentX-250,CentY-50);
  amove(CentX+50,CentY+10);
  aline(CentX+226,CentY+98);
  aearc(4,1,CentX+50,CentY+10,CentX+291,CentY-22,1);
  aline(CentX+50,CentY+10);
  rline(0,-17);                                        (* relative line *)
  amove(CentX+300,CentY+10);
  rline(0,-50);
  aearc(4,1,CentX+50,CentY-40,CentX+291,CentY-72,1);
  rline(0,50);
  amove(CentX+291,CentY-72);
  rline(-50,7);
  amove(CentX+176,CentY+88);
  rline(0,-16);

  opmod(1);                            (* OR mode ON *)
  colors(Black,Black);                 (* Black =! 0 ==> no drawing *)
  chrct(ord('$'),2,2,0);               (* draw $ invisible ==> pattern RAM *)
  colors(LightBlue,LightYellow);
  amove(CentX-10,CentY-10);
  paint(LightWhite,0);                 (* fill closed area with $ *)
  colors(LightCyan,LightCyan);
  amove(CentX,CentY-130);
  paint(LightWhite,0);
  colors(Cyan,Cyan);                   (* Cyan ==> XHR *)
  amove(CentX+40,CentY);
  paint(LightWhite,0);                 (* fill closed area with cyan *)
  colors(Black,Black);                 (* Balck =! 0 ==> no drawing *)
  chrct(ord('%'),2,2,0);               (* draw % invisible ==> pattern RAM *)
  colors(LightRed,LightCyan);
  amove(CentX+100,CentY+10);
  paint(LightWhite,0);                 (* fill closed area with % *)
  amove(CentX+52,CentY);
  colors(LightGreen,LightGreen);       (* LightGreen ==> XHR *)
  paint(LightWhite,0);                 (* fill closed area with LightGreen *)
  amove(CentX+293,CentY-47);
  colors(Green,Green);                 (* Green ==> XHR *)
  paint(LightWhite,0);                 (* fill closed area with green *)
  opmod(0);                            (* Replace mode ON *)

  ResetKeyTest(2000);
  repeat
    KeyTest;                           (* check keyboard *)
    delay(1);
  until EndProc;

end;


(*******************************
 *                             *
 *       DEMO: FilledArea      *
 *                             *
 *******************************)

procedure FilledArea;

const
  LineTab1: array[0..63] of integer =
  (64,-64,64,64,64,-64,64,64,
   64,-64,64,64,64,-64,64,64,
   64,-64,64,64,64,-64,64,64,
   64,-64,64,64,64,-64,64,64,
   64,-64,64,64,64,-64,64,64,
   64,-64,64,64,64,-64,64,64,
   64,-64,64,64,64,-64,64,64,
   64,-64,64,64,64,-64,64,64);

  LineTab2: array[0..47] of integer =
   (270,220,270,290,320,290,320,240,
    370,240,370,320,410,320,410,220,
    500,320,550,190,550,190,550,300,
    590,300,590,160,490,160,510,230,
    390,110,480,110,480,70,360,70,
    360,20,310,20,310,80,200,200);

var
  Count: integer;

begin

  (***** erase picture with zigzag lines *****)

  opmod(0);
  colors(LightYellow,LightYellow);
  for Count:=0 to YWidth div 2 +32 do
  begin
    amove(0,64 +YWidth -Count);
    rpll(XWidth div 64 +1,ofs(LineTab1),seg(LineTab1));
    amove(0,Count);
    rpll(XWidth div 64 +1,ofs(LineTab1),seg(LineTab1));
  end;
  colors(Black,Black);
  for Count:=YWidth div 2 +32 downto 0 do
  begin
    amove(0,64 +YWidth -Count);
    rpll(XWidth div 64 +1,ofs(LineTab1),seg(LineTab1));
    amove(0,Count);
    rpll(XWidth div 64 +1,ofs(LineTab1),seg(LineTab1));
  end;

  comment(UpperScreen,'Minimal Softwareproblems:');
  comment(LowerScreen,'Filling of Enclosed Areas');

  (***** perform filling of closed area *****)

  deforg(CentX-320,CentY-200);
  amove(200,200);                              (* move CP *)
  colors(LightWhite,LightWhite);               (* LightWhite ==> XHR *)
  apll(24,ofs(LineTab2),seg(LineTab2));        (* absolute polyline *)
  amove(300,200);                              (* move CP *)
  colors(Red,Red);                             (* Red ==> XHR *)
  paint(LightWhite,0);                         (* fill closed area *)
  if lower then deforg(0,40) else deforg(0,0);


  ResetKeyTest(2000);
  repeat
    KeyTest;                                   (* check keyboard *)
    delay(1);
  until EndProc;

end;

(*******************************
 *                             *
 *       DEMO: FullSteam       *
 *                             *
 *******************************)

procedure FullSteam;

const
 ColorTab : array[0..19] of byte =
  (1,14,
   2,13,
   4,11,
   5,10,
   6,9,
   5,10,
   4,11,
   2,13,
   1,14,
   0,15);

var
  Count: integer;

procedure DoPaint(XPos,YPos: integer);

(* fills pattern RAM with random patterns.
   moves CP and fills closed area *)

begin
  amove(XPos,YPos);
  fptn(16,16,random(4)+1,random(16),0);
  colors(ColorTab[Count],ColorTab[Count+1]);
  paint(Cyan,0);
  Count:=(Count+2) mod 20;
end;


begin

  (***** erase picture with some effects *****)

  opmod(0);
  colors(Green,Green);
  for Count:=XWidth div 2 downto 0 do
  begin
    amove(CentX-Count,CentY-Round(CentY/CentX*Count));
    rrct(2*Count,trunc(CentY/CentX*2*Count));
  end;
  colors(Black,Black);
  for Count:=0 to XWidth div 2 do
  begin
    amove(CentX-Count,CentY-Round(CentY/CentX*Count));
    rrct(2*Count,trunc(CentY/CentX*2*Count));
  end;

  comment(UpperScreen,'Full Steam:');
  comment(LowerScreen,'1.660.000 Operations/s');

  (***** drawing of limitation lines *****)

  colors(Cyan,Cyan);                           (* Cyan ==> XHR *)
  amove(0,0);                                  (* move to lowerleft corner *)
  rrct(XWidth-1,YWidth-1);                     (* relative rectangle *)
  amove(CentX,CentY);                          (* move to center *)
  crcl(CentY);                                 (* circle *)
  amove((CentX-CentY) div 2,CentY);
  crcl((CentX-CentY) div 2 -3);
  amove(XWidth-(CentX-CentY) div 2,CentY);
  crcl((CentX-CentY) div 2 -3);
  amove((CentX-CentY) div 2 + 10,(CentX-CentY) div 2 + 10);
  crcl((CentX-CentY) div 2 -10);
  amove((CentX-CentY) div 2 +10,YWidth-(CentX-CentY) div 2 -90);
  crcl((CentX-CentY) div 2 -10);
  amove(XWidth-(CentX-CentY) div 2 -10,(CentX-CentY) div 2 +10);
  crcl((CentX-CentY) div 2 -10);
  amove(XWidth-(CentX-CentY) div 2 -10,YWidth-(CentX-CentY) div 2 -90);
  crcl((CentX-CentY) div 2 -10);

  ResetKeyTest(5);
  Count:=0;
  repeat
    DoPaint(CentX,CentY);              (* fill pattern Ram and paint *)
    DoPaint(1,1);
    DoPaint(XWidth-2,1);
    DoPaint((CentX-CentY) div 2,CentY);
    DoPaint(XWidth-(CentX-CentY) div 2,CentY);
    DoPaint((CentX-CentY) div 2 + 10,(CentX-CentY) div 2 + 10);
    DoPaint((CentX-CentY) div 2 +10,YWidth-(CentX-CentY) div 2 -90);
    DoPaint(XWidth-(CentX-CentY) div 2 -10,(CentX-CentY) div 2 +10);
    DoPaint(XWidth-(CentX-CentY) div 2 -10,YWidth-(CentX-CentY) div 2 -90);
    wposit(Random(XWidth-144),Random(YWidth-64));
    KeyTest;                                           (* check keyboard *)
  until EndProc;

  wposit(XWidth-160,10);

end;



(*******************************
 *                             *
 *       Main Program          *
 *                             *
 *******************************)



begin
  ParsParams;
  init;
  if getrev<(1*256+6) then
  begin
    writeln;
    writeln(#7,'This Demo works only with XHRDRV.SYS V1.6 and later');
    halt(0);
  end;
  clrscr;
  write('"X"=Next screen, "Q"=End ');
  repeat;
    presents;
    if not Quit then circles;
    if not Quit then ellipses;
    if not Quit then arcs;
    if not Quit then sweep;

    if not Quit then BaseZoom;
    if not Quit then FilledRects;

    if not Quit then Cake;
    if not Quit then FilledArea;

    if not Quit then FullSteam;
  until Quit;
  xhrini(0,0);
  writeln;
  writeln('End of XHRDEMO');
  show(-1,0,0);      (* disable screen output on single screen systems *)
end.


